<?php 
if(!function_exists('wc_add_shared_woocommerce_metaboxes'))
{
	//Save data
	add_action( 'woocommerce_process_product_meta', 'wc_shared_woocommerce_process_product_meta',10,1);
	add_action( 'woocommerce_save_product_variation', 'wc_shared_woocommerce_process_product_meta' ,10,1); //Only for WC 2.5
	
	//Product field
	//add_action( 'woocommerce_product_options_general_product_data', 'wc_shared_add_cost_field' );
	add_action( 'woocommerce_product_options_pricing', 'wc_shared_add_single_cost_field',1,1 );
	add_action( 'woocommerce_variation_options_pricing', 'wc_shared_add_variation_cost_field',  1, 3  );  //Only for WC 2.5
	
	function wc_shared_add_woocommerce_metaboxes()
	{
		add_meta_box( 'wc-shared-profit-box', __('Tracking Code', 'woocommerce-product-stats'), array( &$this, 'wc_shared_add_cost_field' ), 'product', 'side', 'high');
	}
	function wc_shared_add_single_cost_field($data)
	{
		global $post;
		wc_shared_add_cost_field($post->ID);
	} 
	function wc_shared_add_variation_cost_field($loop, $variation_data, $variation)
	{
		//wcpst_var_dump($variation);
		wc_shared_add_cost_field($variation->ID);
	} 
	function wc_shared_add_cost_field( $post_id )
	{
		?>
		<style>
		.form-field._wc_share_cost_field > label {
				clear: both;
				display: block;
			}
		</style>
		<?php 
		global $wcpst_product_model;
		$woocommerce_cost_field = $wcpst_product_model->get_product_meta($post_id, '_wcpst_shared_purchase_price', "");
		woocommerce_wp_text_input( 
			array( 
				'id'         	 => '_wcpst_shared_purchase_price_'.$post_id, 
				'wrapper_class'  => '_wcpst_shared_purchase_price', 
				'label'      	 => __( 'Purchase price', 'woocommerce-product-stats' ), 
				'placeholder' 	 => '1.0',
				'desc_tip'    	 => 'true',
				'type'              => 'number', 
				'custom_attributes' => array(
						'step' 	=> 'any',
						'min'	=> '0'
					) ,
				'description' 	 => __( 'Enter the price at which the product has been bought.', 'woocommerce-product-stats' ),
				'value'		 	 => $woocommerce_cost_field/* ,
				'style'		 	 => 'display:block;' */
			)
		);
	}
	function wc_shared_woocommerce_process_product_meta($post_id)
	{
		global $wcpst_product_model;
		// Text Field
		$woocommerce_cost_field = $_POST['_wcpst_shared_purchase_price_'.$post_id];
	/* 	 wcpst_var_dump($post_id);
		wcpst_var_dump($woocommerce_cost_field); 
		wp_die(); */
		if( !empty( $woocommerce_cost_field ) )
			$wcpst_product_model->save_product_meta($post_id, '_wcpst_shared_purchase_price', esc_attr( $woocommerce_cost_field ));
	}
}
?>