<?php 
class WCPST_Html
{
	public function __construct()
	{
		if(is_admin())
		{
			add_action('wp_ajax_render_product_card', array(&$this, 'render_product_card'));
		}
	} 
	public static function enqueue_scripts()
	{
		wp_enqueue_script('wcpst-console-override', WCPST_PLUGIN_URL.'/js/admin-console-override.js', array( 'jquery' ));
	}
	public function render_product_card()
	{
		if(!isset($_POST['product_id']))
			wp_die();
		global $wcpst_wpml_helper, $wcpst_product_model;
		
		$product_id = $_POST['product_id'];
		$product_id = $wcpst_wpml_helper->get_original_id($product_id);
		$product = new WC_Product($product_id);
		$widget_contaniner_unique_id = rand(1213, 21321323);
		?>
		
		<div class="white_box wcpst_product_card" id="wcpst_product_card_<?php echo $widget_contaniner_unique_id; ?>" data-product_id="<?php echo $product_id; ?>">
			<button class="button delete_button" data-id="<?php echo $widget_contaniner_unique_id; ?>" onclick="wcpst_remove_card(event);" ><?php _e('Remove', 'woocommerce-attach-me'); ?></button>
			<h2><?php echo $product->get_title( ); ?></h2>
			
			<!-- range data selection (changes according to earing_period_range type) -->
			<p>
			<?php _e('If a data range is not selected, the displayed stats are relative to the current month: ', 'woocommerce-product-stats'); echo '<strong>'.date('F').'</strong>'; ?>
			</p>
			<div class="wcpst_date_selector">
				<input class="wcpst_range_datepicker" type="text" id="wcpst_earning_picker_start_date_<?php echo $widget_contaniner_unique_id; ?>" name="wcpst_start_date" value="" placeholder="<?php _e('Start date', 'woocommerce-product-stats' ); ?>" />
				<input class="wcpst_range_datepicker" type="text" id="wcpst_earning_picker_end_date_<?php echo $widget_contaniner_unique_id; ?>" name="wcpst_end_date" value="" placeholder="<?php _e('End date', 'woocommerce-product-stats' ); ?>" />
				<div class="wcpst_spacer"></div>
				<input class="button-primary wcpst_filter_button" id="wcpst_date_filter_button_<?php echo $widget_contaniner_unique_id; ?>" type="submit" value="<?php _e('Select period', 'woocommerce-product-stats' ); ?>" >  </input>
			</div>
			
			<div class="wcpst_widget_row dropzone">
			
			<?php 
			//Base price discover;
			$is_variable = WCPST_Product::is_variable($product_id); 
			$variations_base_prices = array();
			$has_base_price = true;
			if(!$is_variable)
				$has_base_price = $wcpst_product_model->get_product_meta_sql($product_id,'_wcpst_shared_purchase_price',null);
			else
			{
				$variations = WCPST_Product::get_variations($product_id);
				foreach($variations as $variation)
				{
					$name = WCPST_Product::get_variation_complete_name($variation->ID);
					if(isset($name) && $name != "")
					{
						$has_base_price = $wcpst_product_model->get_product_meta_sql($variation->ID,'_wcpst_shared_purchase_price',null);
						$variations_base_prices[] = array('name' => "(#".$variation->ID.") ".$name, 'base_price'=> isset($has_base_price) ? true : false );
						if(!$has_base_price)
							$has_base_price = false;
					}
				}
			}
			?>
			<div class="wcpst_base_price_warning <?php if($has_base_price) echo "wcuf_green"; else echo "wcuf_red"?>">
					<a href="#" class="tooltip">
						<?php if($has_base_price) _e('The product (and all its variants) has a purchase price', 'woocommerce-product-stats' );
							   else _e("The product (or at least one of its variants) hasn't a purchase price (in case of variable product, roll over on this box to discover which)", 'woocommerce-product-stats' ); 
						
						if(!$has_base_price): ?>
						<span>
							<?php 
							if(!$is_variable)
								_e('Go to product edit page page and add a purchase price', 'woocommerce-attach-me'); 
							else
							{
								echo "<ol>";
								foreach($variations_base_prices as $variation)
								{
									if(!$variation['base_price'])
										echo "<li>".$variation['name']."</li>";
								}
								echo "</ol>";
							}
								?>
						</span>
						<?php endif; ?>
					</a>
				</div>
			<?php 
			
				//wcpst_var_dump($product); 
				$unique_id = rand(1213, 21321323);
				$this->widget_earnings_per_period_chart($unique_id,$product_id, $widget_contaniner_unique_id);
				$unique_id = rand(1213, 21321323);
				$this->widget_earnings_per_area_chart($unique_id,$product_id, $widget_contaniner_unique_id);
				
			?>
			</div>
			<div class="wcpst_widget_row dropzone">
			<?php 
				$unique_id = rand(1213, 21321323);
				$this->widget_earnings_per_customer_chart($unique_id,$product_id, $widget_contaniner_unique_id);
				$unique_id = rand(1213, 21321323);
				$this->widget_earnings_per_payment_method_chart($unique_id,$product_id, $widget_contaniner_unique_id);
			?>
			</div>
			<div class="wcpst_widget_row dropzone">
			<?php 
				$unique_id = rand(1213, 21321323);
				$this->widget_products_related_chart($unique_id,$product_id, $widget_contaniner_unique_id);
			?>
			</div>
		</div>
		<?php 
		wp_die();
	}
	
	
	private function widget_earnings_per_period_chart($id,$product_id, $widget_contaniner_unique_id)
	{
		$is_variable = WCPST_Product::is_variable($product_id);
		?>
		<div class="wcpst_widget_container yes-drop" id="wcpst_widget_container_<?php echo $id; ?>">
			<h2><?php _e('Earnings per period', 'woocommerce-product-stats' ); ?></h2>
			<div id="wcpst_change_view_container_<?php echo $id; ?>">
				<select id="wcpst_earning_period_range_<?php echo $id; ?>" name='wcpst_earning_period_range'>
				  <option value="daily" ><?php _e('Daily View', 'woocommerce-product-stats' ); ?></option>
				  <option value="monthly" ><?php _e('Monthly View', 'woocommerce-product-stats' ); ?></option>
				  <option value="yearly" ><?php _e('Yearly View', 'woocommerce-product-stats' ); ?></option>
				</select>
				
				<select style="<?php if(!$is_variable) echo "display:none;";?>" id="wcpst_variation_id_<?php echo $id; ?>">
					<option value="all"><?php _e('All variations', 'woocommerce-product-stats' ); ?></option>
					<?php if($is_variable):
							$variations = WCPST_Product::get_variations($product_id);
							foreach($variations as $variation)
							{
								$name = WCPST_Product::get_variation_complete_name($variation->ID);
								if(isset($name) && $name != "")
									echo '<option value="'.$variation->ID.'">'.$name.'</option>';
							}
							?>
					<?php endif; ?>
				</select>
				<input class="button-primary wcpst_filter_button" id="wcpst_earnings_chart_filter_by_view_type_button_<?php echo $id; ?>" type="submit" value="<?php _e('Apply', 'woocommerce-product-stats' ); ?>" >  </input>	
			</div>	
			<div class="chart">
				<!--<h2 class="stat-title"><?php _e('Earnings', 'woocommerce-product-stats' ); ?></h2>-->
				<div id="wcpst_earning_wait_box_<?php echo $id; ?>" class="wcpst_wait_box">
						<?php _e('Computing data, please wait...', 'woocommerce-product-stats' ); ?>
						<img class="wcpst_preloader_image" src="<?php echo WCPST_PLUGIN_URL.'/img/preloader.gif' ?>" ></img>
				</div>
				<div id="wcpst_earning_stats_canvas_box_<?php echo $id; ?>" class="wcpst_earning_stats">
					<canvas id="wcpst_earning_stats_<?php echo $id; ?>" ></canvas>
				</div>			
			</div>
			<div class="wcpst_spacer2"></div>
			<div id="wcpst_earning_stats_table_<?php echo $id; ?>" class="wcpst_table">
					<table id="wcpst_product_table_<?php echo $id; ?>" class="display striped" cellspacing="0" width="100%" ><!--class="wp-list-table widefat fixed customers"-->
						<thead>
								<tr>
									<th scope="col" class="manage-column column-date" style=""><?php  _e('Date', 'woocommerce-product-stats');?></th>
									<th scope="col" class="manage-column column-sales-count sortable" style=""><?php  _e('Item sales count', 'woocommerce-product-stats');?></th>
									<th scope="col" class="manage-column column-earning sortable" style=""><?php  _e('Earnings', 'woocommerce-product-stats');?></th>
								</tr>
						</thead>
						<tbody id="wcpst_table_body_<?php echo $id; ?>">
						</tbody>
						<tfoot>
								<tr>
									<th scope="col" class="manage-column column-id" id=""><?php  _e('Total', 'woocommerce-product-stats');?></th>
									<th scope="col" class="manage-column column-sales-count sortable" id="wcpst_products_foot_total_item_count_<?php echo $id; ?>"></th>
									<th scope="col" class="manage-column column-earnings sortable" id="wcpst_foot_total_earnings_<?php echo $id; ?>"></th>
								</tr>
						</tfoot>
					</table>
			</div>
		</div>
		<script>
		var wcpst_earning_widget_<?php echo $id; ?> = new Earning_per_period_chart(<?php echo $id; ?>, <?php echo $product_id; ?>, <?php echo $widget_contaniner_unique_id; ?>);
		</script>
		<?php 
	}
	
	private function widget_earnings_per_area_chart($id,$product_id, $widget_contaniner_unique_id)
	{
		$is_variable = WCPST_Product::is_variable($product_id);
		?>
		<div class="wcpst_widget_container  yes-drop" id="wcpst_widget_container_<?php echo $id; ?>">
			<h2><?php _e('Earnings per area', 'woocommerce-product-stats' ); ?></h2>
			<div id="wcpst_change_view_container_<?php echo $id; ?>">
				<select id="wcpst_geographic_view_type_<?php echo $id; ?>" name='wcpst_geographic_view_type'>
				  <option value="country" ><?php _e('Country', 'woocommerce-dashboard-stats' ); ?></option>
				  <option value="state" ><?php _e('State/Province', 'woocommerce-dashboard-stats' ); ?></option>
				</select>
				
				
				<select style="<?php if(!$is_variable) echo "display:none;";?>" id="wcpst_variation_id_<?php echo $id; ?>">
					<option value="all"><?php _e('All variations', 'woocommerce-product-stats' ); ?></option>
					<?php if($is_variable):
							$variations = WCPST_Product::get_variations($product_id);
							foreach($variations as $variation)
							{
								$name = WCPST_Product::get_variation_complete_name($variation->ID);
								if(isset($name) && $name != "")
									echo '<option value="'.$variation->ID.'">'.$name.'</option>';
							}
							?>
					<?php endif; ?>
				</select>			
				<input class="button-primary wcpst_filter_button" id="wcpst_earnings_chart_filter_by_view_type_button_<?php echo $id; ?>" type="submit" value="<?php _e('Apply', 'woocommerce-product-stats' ); ?>" >  </input>	
			</div>
			
			<div class="chart">
				<!--<h2 class="stat-title"><?php _e('Earnings', 'woocommerce-product-stats' ); ?></h2>-->
				<div id="wcpst_earning_wait_box_<?php echo $id; ?>" class="wcpst_wait_box">
						<?php _e('Computing data, please wait...', 'woocommerce-product-stats' ); ?>
						<img class="wcpst_preloader_image" src="<?php echo WCPST_PLUGIN_URL.'/img/preloader.gif' ?>" ></img>
				</div>
				<div id="wcpst_earning_stats_canvas_box_<?php echo $id; ?>" class="wcpst_earning_stats">
					<canvas id="wcpst_earning_stats_<?php echo $id; ?>" ></canvas>
				</div>			
			</div>
			<div class="wcpst_spacer2"></div>
			<div id="wcpst_earning_stats_table_<?php echo $id; ?>" class="wcpst_table">
					<table id="wcpst_product_table_<?php echo $id; ?>" class="display striped" cellspacing="0" width="100%" ><!--class="wp-list-table widefat fixed customers"-->
						<thead>
								<tr>
									<th style="" class="manage-column column-date" scope="col"><?php _e('Area', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-count" scope="col"><?php _e('Item Sales Count', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-earnings num" scope="col"><?php _e('Earnings', 'woocommerce-dashboard-stats' ); ?></th>
								</tr>
						</thead>
						<tbody id="wcpst_table_body_<?php echo $id; ?>">
						</tbody>
						<tfoot>
								<tr>
									<th scope="col" class="manage-column column-id" id=""><?php  _e('Total', 'woocommerce-product-stats');?></th>
									<th scope="col" class="manage-column column-sales-count sortable" id="wcpst_geographic_foot_total_count_<?php echo $id; ?>"></th>
									<th scope="col" class="manage-column column-earnings sortable" id="wcpst_geographic_foot_total_earnings_<?php echo $id; ?>"></th>
								</tr>
						</tfoot>
					</table>
			</div>
		</div>
		<script>
		var wcpst_earning_geo_widget_<?php echo $id; ?> = new Earning_geo_per_period_chart(<?php echo $id; ?>, <?php echo $product_id; ?>, <?php echo $widget_contaniner_unique_id; ?>);
		</script>
		<?php 
	}
	private function widget_earnings_per_customer_chart($id,$product_id, $widget_contaniner_unique_id)
	{
		$is_variable = WCPST_Product::is_variable($product_id);
		?>
		<div class="wcpst_widget_container  yes-drop" id="wcpst_widget_container_<?php echo $id; ?>">
		<h2><?php _e('Earnings per customer', 'woocommerce-product-stats' ); ?></h2>
			<div id="wcpst_change_view_container_<?php echo $id; ?>">
				<select style="<?php if(!$is_variable) echo "display:none;";?>" id="wcpst_variation_id_<?php echo $id; ?>">
					<option value="all"><?php _e('All variations', 'woocommerce-product-stats' ); ?></option>
					<?php if($is_variable):
							$variations = WCPST_Product::get_variations($product_id);
							foreach($variations as $variation)
							{
								$name = WCPST_Product::get_variation_complete_name($variation->ID);
								if(isset($name) && $name != "")
									echo '<option value="'.$variation->ID.'">'.$name.'</option>';
							}
							?>
					<?php endif; ?>
				</select>
				<?php if($is_variable): ?>
					<input class="button-primary wcpst_filter_button" id="wcpst_earnings_chart_filter_by_view_type_button_<?php echo $id; ?>" type="submit" value="<?php _e('Apply', 'woocommerce-product-stats' ); ?>" >  </input>	
				<?php endif; ?>
			</div>
			<div class="chart">
				<!--<h2 class="stat-title"><?php _e('Earnings', 'woocommerce-product-stats' ); ?></h2>-->
				<div id="wcpst_earning_wait_box_<?php echo $id; ?>" class="wcpst_wait_box">
						<?php _e('Computing data, please wait...', 'woocommerce-product-stats' ); ?>
						<img class="wcpst_preloader_image" src="<?php echo WCPST_PLUGIN_URL.'/img/preloader.gif' ?>" ></img>
				</div>
				<div id="wcpst_earning_stats_canvas_box_<?php echo $id; ?>" class="wcpst_earning_stats">
					<canvas id="wcpst_earning_stats_<?php echo $id; ?>" ></canvas>
				</div>			
			</div>
			<div class="wcpst_spacer2"></div>
			<div id="wcpst_earning_stats_table_<?php echo $id; ?>" class="wcpst_table">
					<table id="wcpst_product_table_<?php echo $id; ?>" class="display striped" cellspacing="0" width="100%" ><!--class="wp-list-table widefat fixed customers"-->
						<thead>
								<tr>
									<th style="" class="manage-column column-date" scope="col"><?php _e('Name', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-count" scope="col"><?php _e('Guest', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-num-purchases" scope="col"><?php _e('# Purchases', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-earnings" scope="col"><?php _e('Spent', 'woocommerce-dashboard-stats' ); ?></th>
								</tr>
						</thead>
						<tbody id="wcpst_table_body_<?php echo $id; ?>">
						</tbody>
						<tfoot>
								<tr>
									<th scope="col" class="manage-column column-id" id=""><?php  _e('Total', 'woocommerce-product-stats');?></th>
									<th scope="col" class="manage-column column-id" id=""></th>
									<th scope="col" class="manage-column column-sales-count sortable" id="wcpst_foot_total_item_count_<?php echo $id; ?>"></th>
									<th scope="col" class="manage-column column-earnings sortable" id="wcpst_foot_total_earnings_<?php echo $id; ?>"></th>
								</tr>
						</tfoot>
					</table>
			</div>
		</div>
		<script>
		var wcpst_earning_customers_widget_<?php echo $id; ?> = new Earning_customers_per_period_chart(<?php echo $id; ?>, <?php echo $product_id; ?>, <?php echo $widget_contaniner_unique_id; ?>);
		</script>
		<?php 
	}
	private function widget_earnings_per_payment_method_chart($id,$product_id, $widget_contaniner_unique_id)
	{
		$is_variable = WCPST_Product::is_variable($product_id);
		?>
		<div class="wcpst_widget_container  yes-drop" id="wcpst_widget_container_<?php echo $id; ?>">
			<h2><?php _e('Earnings per payment method', 'woocommerce-product-stats' ); ?></h2>
			<div id="wcpst_change_view_container_<?php echo $id; ?>">
				<select style="<?php if(!$is_variable) echo "display:none;";?>" id="wcpst_variation_id_<?php echo $id; ?>">
					<option value="all"><?php _e('All variations', 'woocommerce-product-stats' ); ?></option>
					<?php if($is_variable):
							$variations = WCPST_Product::get_variations($product_id);
							foreach($variations as $variation)
							{
								$name = WCPST_Product::get_variation_complete_name($variation->ID);
								if(isset($name) && $name != "")
									echo '<option value="'.$variation->ID.'">'.$name.'</option>';
							}
							?>
					<?php endif; ?>
				</select>
				<?php if($is_variable): ?>
					<input class="button-primary wcpst_filter_button" id="wcpst_earnings_chart_filter_by_view_type_button_<?php echo $id; ?>" type="submit" value="<?php _e('Apply', 'woocommerce-product-stats' ); ?>" >  </input>	
				<?php endif; ?>
			</div>
			<div class="chart">
				<!--<h2 class="stat-title"><?php _e('Earnings', 'woocommerce-product-stats' ); ?></h2>-->
				<div id="wcpst_earning_wait_box_<?php echo $id; ?>" class="wcpst_wait_box">
						<?php _e('Computing data, please wait...', 'woocommerce-product-stats' ); ?>
						<img class="wcpst_preloader_image" src="<?php echo WCPST_PLUGIN_URL.'/img/preloader.gif' ?>" ></img>
				</div>
				<div id="wcpst_earning_stats_canvas_box_<?php echo $id; ?>" class="wcpst_earning_stats">
					<canvas id="wcpst_earning_stats_<?php echo $id; ?>" ></canvas>
				</div>			
			</div>
			<div class="wcpst_spacer2"></div>
			<div id="wcpst_earning_stats_table_<?php echo $id; ?>" class="wcpst_table">
					<table id="wcpst_product_table_<?php echo $id; ?>" class="display striped" cellspacing="0" width="100%" ><!--class="wp-list-table widefat fixed customers"-->
						<thead>
								<tr>
									<th style="" class="manage-column column-date" scope="col"><?php _e('Title', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-count" scope="col"><?php _e('Code', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-num-purchases" scope="col"><?php _e('# Purchases', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-earnings" scope="col"><?php _e('Earnings', 'woocommerce-dashboard-stats' ); ?></th>
								</tr>
						</thead>
						<tbody id="wcpst_table_body_<?php echo $id; ?>">
						</tbody>
						<tfoot>
								<tr>
									<th scope="col" class="manage-column column-id" id=""><?php  _e('Total', 'woocommerce-product-stats');?></th>
									<th scope="col" class="manage-column column-id" id=""></th>
									<th scope="col" class="manage-column column-sales-count sortable" id="wcpst_foot_total_item_count_<?php echo $id; ?>"></th>
									<th scope="col" class="manage-column column-earnings sortable" id="wcpst_foot_total_earnings_<?php echo $id; ?>"></th>
								</tr>
						</tfoot>
					</table>
			</div>
		</div>
		<script>
		var wcpst_earning_payment_method_widget_<?php echo $id; ?> = new Earning_payment_methods_per_period_chart(<?php echo $id; ?>, <?php echo $product_id; ?>, <?php echo $widget_contaniner_unique_id; ?>);
		</script>
		<?php 
	}
	private function widget_products_related_chart($id,$product_id, $widget_contaniner_unique_id)
	{
		$is_variable = WCPST_Product::is_variable($product_id);
		?>
		<div class="wcpst_widget_container  yes-drop" id="wcpst_widget_container_<?php echo $id; ?>">
			<h2><?php _e('Best related products', 'woocommerce-product-stats' ); ?></h2>
			<div id="wcpst_change_view_container_<?php echo $id; ?>">
				<select style="<?php if(!$is_variable) echo "display:none;";?>" id="wcpst_variation_id_<?php echo $id; ?>">
					<option value="all"><?php _e('All variations', 'woocommerce-product-stats' ); ?></option>
					<?php if($is_variable):
							$variations = WCPST_Product::get_variations($product_id);
							foreach($variations as $variation)
							{
								$name = WCPST_Product::get_variation_complete_name($variation->ID);
								if(isset($name) && $name != "")
									echo '<option value="'.$variation->ID.'">'.$name.'</option>';
							}
							?>
					<?php endif; ?>
				</select>
				<?php if($is_variable): ?>
					<input class="button-primary wcpst_filter_button" id="wcpst_earnings_chart_filter_by_view_type_button_<?php echo $id; ?>" type="submit" value="<?php _e('Apply', 'woocommerce-product-stats' ); ?>" >  </input>	
				<?php endif; ?>
			</div>
			<div class="chart">
				<!--<h2 class="stat-title"><?php _e('Earnings', 'woocommerce-product-stats' ); ?></h2>-->
				<div id="wcpst_earning_wait_box_<?php echo $id; ?>" class="wcpst_wait_box">
						<?php _e('Computing data, please wait...', 'woocommerce-product-stats' ); ?>
						<img class="wcpst_preloader_image" src="<?php echo WCPST_PLUGIN_URL.'/img/preloader.gif' ?>" ></img>
				</div>
				<div id="wcpst_earning_stats_canvas_box_<?php echo $id; ?>" class="wcpst_earning_stats">
					<canvas id="wcpst_earning_stats_<?php echo $id; ?>" ></canvas>
				</div>			
			</div>
			<div class="wcpst_spacer2"></div>
			<div id="wcpst_earning_stats_table_<?php echo $id; ?>" class="wcpst_table">
					<table id="wcpst_product_table_<?php echo $id; ?>" class="display striped" cellspacing="0" width="100%" ><!--class="wp-list-table widefat fixed customers"-->
						<thead>
								<tr>
									<th style="" class="manage-column column-id" scope="col"><?php _e('ID', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-title" scope="col"><?php _e('Title', 'woocommerce-dashboard-stats' ); ?></th>
									<th style="" class="manage-column column-num-purchases" scope="col"><?php _e('# Orders', 'woocommerce-dashboard-stats' ); ?></th>
								</tr>
						</thead>
						<tbody id="wcpst_table_body_<?php echo $id; ?>">
						</tbody>
						<tfoot>
								<tr>
									<th scope="col" class="manage-column column-id" id=""><?php  _e('Total', 'woocommerce-product-stats');?></th>
									<th scope="col" class="manage-column column-empty" id=""></th>
									<th scope="col" class="manage-column column-earnings sortable" id="wcpst_foot_total_orders_<?php echo $id; ?>"></th>
								</tr>
						</tfoot>
					</table>
			</div>
		</div>
		<script>
		var wcpst_products_related_widget_<?php echo $id; ?> = new Products_related_per_period_chart(<?php echo $id; ?>, <?php echo $product_id; ?>, <?php echo $widget_contaniner_unique_id; ?>);
		</script>
		<?php 
	}
}
?>