<?php 
class WCPST_Order
{
	public function __construct()
	{
		if(is_admin())
		{
			add_action('wp_ajax_wcpst_earning_widget_get_earning_per_period', array(&$this, 'ajax_get_earning_per_period') );
			add_action('wp_ajax_wcpst_geographic_widget_get_earning_per_area', array(&$this, 'ajax_get_earning_per_geograpic_area') );
			add_action('wp_ajax_wcpst_customers_widget_get_earnings_per_period', array(&$this, 'ajax_get_customers_per_period') );
			add_action('wp_ajax_wcpst_payment_methods_widget_get_per_period', array(&$this, 'ajax_get_payment_methods_per_period') );
			add_action('wp_ajax_wcpst_products_related', array(&$this, 'ajax_get_products_related') );
		}
	}
	public function ajax_get_earning_per_geograpic_area()
	{
		global $wcpst_product_model;
		$range = isset($_POST['view_type']) ? $_POST['view_type'] : 'country'; //country, state, city
		$start_date = isset($_POST['start_date']) ? $_POST['start_date'] : null;
		$end_date = isset($_POST['end_date']) ? $_POST['end_date'] : null;
		$product_id = isset($_POST['product_id']) ? $_POST['product_id'] : null;
		$variation_id = isset($_POST['variation_id']) ? $_POST['variation_id'] : 'all'; 
		
		$results = $this->get_earnings_per_geographic_area($product_id, $variation_id, $range, $start_date, $end_date);
		//$purchase_price = $variation_id != 'all' ? $wcpst_product_model->get_product_meta_sql($variation_id) : $wcpst_product_model->get_product_meta_sql($product_id);
		$countries_translator =  WC()->countries;
		foreach($results as $index => $stat)
		{
			$variation_ids = explode(",", $stat['product_variation_id']);
			$total_purchases = explode(",", $stat['total_purchases']);
			$purchase_prices = $this->get_variations_total_pruchase_prices($variation_ids, $product_id);
			$results[$index]['total_earning'] = number_format($stat['total_earning']-(/* $stat['total_purchases']* */$purchase_prices), 2);
			if($range == 'country')
			{
				$results[$index]['zone_name'] = isset($countries_translator->countries[ $stat['zone_name'] ]) ? $countries_translator->countries[ $stat['zone_name'] ] : "none";
				$results[$index]['zone_code'] =  !empty($stat['zone_name']) ? strtolower( $stat['zone_name']) : "none";
			}
			//Total item purchased
			$temp_total_purchases = 0;
			if(is_array($total_purchases))
				foreach($total_purchases as $temp_purchese_qty)
					$temp_total_purchases +=  $temp_purchese_qty;
			else
				$temp_total_purchases = 1;
			$results[$index]['total_purchases'] = $temp_total_purchases;
		}
		
		usort($results, function($a, $b) {
				return $b['total_earning'] - $a['total_earning'];
			});
		//wcpst_var_dump($results);
		echo json_encode($results);
		wp_die();
	}
	public function ajax_get_earning_per_period()
	{
		global $wcpst_product_model;
		$range = isset($_POST['view_type']) ? $_POST['view_type'] : 'daily';
		$start_date = isset($_POST['start_date']) ? $_POST['start_date'] : null;
		$end_date = isset($_POST['end_date']) ? $_POST['end_date'] : null;
		$product_id = isset($_POST['product_id']) ? $_POST['product_id'] : null;
		$variation_id = isset($_POST['variation_id']) ? $_POST['variation_id'] : 'all'; 
		
		$stats = $this->get_earnings_per_period($product_id, $variation_id, $range, $start_date,$end_date);
		//$purchase_price = $variation_id != 'all' ? $wcpst_product_model->get_product_meta_sql($variation_id) : $wcpst_product_model->get_product_meta_sql($product_id);
		$counter = 0;
		$totals = $quantities = $dates = $total_items ='';
		//wcpst_var_dump($stats);
		foreach($stats as $stat_per_date)
		{
			if($counter > 0)
			{
				$dates .=",";
				$totals .=",";
				$quantities .=",";
			}
			if($range == 'daily')
			{
				 /*setlocale(LC_TIME, 'it_IT');
				$temp_date =  DateTime::createFromFormat('j/m/Y', $stat_per_date['date']);
				$dates .= strftime("%a - %d/%m", $temp_date->getTimestamp()); */
				
				$temp_date =  DateTime::createFromFormat('j/m/Y', $stat_per_date['date']);
				$dates .= $temp_date->format('d/m - D');
			}
			else
				$dates .= $stat_per_date['date']; //date($date_format ,strtotime($order_date))
			
			$variation_ids = explode(",", $stat_per_date['product_variation_id']);
			
			$total_purchases = explode(",", $stat_per_date['product_qty']);
			$purchase_prices = $this->get_variations_total_pruchase_prices($variation_ids, $product_id);
			
			//wcpst_var_dump($stat_per_date['product_total']." - ".$purchase_prices );
			
			//$quantities .= $stat_per_date['product_qty'];
			//Total item purchased
			$temp_total_purchases = 0;
			if(is_array($total_purchases))
				foreach($total_purchases as $temp_purchese_qty)
					$temp_total_purchases +=  $temp_purchese_qty;
			else
				$temp_total_purchases = 1;
			$quantities .= $temp_total_purchases;
			
			$totals .= $stat_per_date['product_total']-( $temp_total_purchases * $purchase_prices);
			
			$counter++;
		}
		echo json_encode(array('dates'=>$dates, 'totals'=>$totals, 'quantities' => $quantities/* , 'total_items' => $total_items */));
		wp_die();
	}
	public function ajax_get_customers_per_period()
	{
		global $wcpst_product_model;
		$start_date = isset($_POST['start_date']) ? $_POST['start_date'] : null;
		$end_date = isset($_POST['end_date']) ? $_POST['end_date'] : null;
		$product_id = isset($_POST['product_id']) ? $_POST['product_id'] : null;
		$variation_id = isset($_POST['variation_id']) ? $_POST['variation_id'] : 'all'; 
		
		$stats = $this->get_customers_per_period($product_id, $variation_id , 'all', $start_date,$end_date);
		//$purchase_price = $variation_id != 'all' ? $wcpst_product_model->get_product_meta_sql($variation_id) : $wcpst_product_model->get_product_meta_sql($product_id);
		//wcds_var_dump($stats);
		/* Format:
			array(2) {
			  [0]=>
			  array(4) {
				["order_total"]=>
				string(4) "15.6"
				["order_num"]=>
				string(1) "2"
				["name"]=>
				string(8) "Domenico"
				["last_name"]=>
				string(6) "Lagudi"
				["customer_id"] =>
				int 1234123
			  }
			  */
		
		foreach($stats as $index => $customer)
		{
			$variation_ids = explode(",", $customer['product_variation_id']);
			$purchase_prices = $this->get_variations_total_pruchase_prices($variation_ids, $product_id);
			
			$total_purchases = explode(",", $customer['product_qty']);
			$temp_total_purchases = 0;
			if(is_array($total_purchases))
				foreach($total_purchases as $temp_purchese_qty)
					$temp_total_purchases +=  $temp_purchese_qty;
			else
				$temp_total_purchases = 1;
			
			$stats[$index]['product_qty'] = $temp_total_purchases;
			$stats[$index]['total_spent'] = $customer['total_spent']-( $temp_total_purchases * $purchase_prices);  //number_format( ... ,2);
			$stats[$index]['permalink'] = $customer['customer_id'] >0 ? get_edit_user_link($customer['customer_id']) : 'none';
			
		}
		echo json_encode($stats);
		wp_die();
	}
	public function ajax_get_payment_methods_per_period()
	{
		global $wcpst_product_model;
		//paymnet -> post meta keys: _payment_method , _payment_method_title
		$start_date = isset($_POST['start_date']) ? $_POST['start_date'] : null;
		$end_date = isset($_POST['end_date']) ? $_POST['end_date'] : null;
		$product_id = isset($_POST['product_id']) ? $_POST['product_id'] : null;
		$variation_id = isset($_POST['variation_id']) ? $_POST['variation_id'] : 'all'; 
		$purchase_price = 0;
		
		$stats = $this->get_earnings_per_payment_method($product_id, $variation_id , $start_date,$end_date);
		//$purchase_price = $variation_id != 'all' ? $wcpst_product_model->get_product_meta_sql($variation_id) : $wcpst_product_model->get_product_meta_sql($product_id);
		/* Format:
		array(1) {
			  [0]=>
			  array(4) {
				["total_earning"]=>
				string(4) "64.8"
				["total_purchases"]=>
				string(1) "8"
				["payment_method"]=>
				string(16) "Cash on Delivery"
				["payment_method_title"]=>
				string(16) "Cash on Delivery"
			  }
			}
			*/
		
		foreach($stats as $index => $stat)
		{
			$variation_ids = explode(",", $stat['product_variation_id']);
			$purchase_prices = $this->get_variations_total_pruchase_prices($variation_ids, $product_id);
			
			$total_purchases = explode(",", $stat['total_purchases']);
			$temp_total_purchases = 0;
			if(is_array($total_purchases))
				foreach($total_purchases as $temp_purchese_qty)
					$temp_total_purchases +=  $temp_purchese_qty;
			else
				$temp_total_purchases = 1;
			
			$stats[$index]['total_purchases'] = $temp_total_purchases;
			
			$stats[$index]['total_earning'] = number_format($stat['total_earning']-($temp_total_purchases * $purchase_prices), 2);
		}
		echo json_encode($stats);
		wp_die();
	}
	private function get_variations_total_pruchase_prices($variation_ids, $product_id)
	{
		global $wcpst_product_model;
		$purchase_price = 0;
		//wcpst_var_dump($variation_ids);
		if(is_array($variation_ids))
		{
			foreach((array)$variation_ids as $temp_variation_id)
			{
				if($temp_variation_id != 0)
					$purchase_price += $wcpst_product_model->get_product_meta_sql($temp_variation_id);
				else
					$purchase_price = $wcpst_product_model->get_product_meta_sql($product_id);
			}
		}
		else if($variation_ids != 0)
			$purchase_price = $wcpst_product_model->get_product_meta_sql($variation_ids);
		else
			$purchase_price = $wcpst_product_model->get_product_meta_sql($product_id);
		
		return $purchase_price;
	}
	public function ajax_get_products_related()
	{
		global $wcpst_product_model;
		//paymnet -> post meta keys: _payment_method , _payment_method_title
		$start_date = isset($_POST['start_date']) ? $_POST['start_date'] : null;
		$end_date = isset($_POST['end_date']) ? $_POST['end_date'] : null;
		$product_id = isset($_POST['product_id']) ? $_POST['product_id'] : null;
		$variation_id = isset($_POST['variation_id']) ? $_POST['variation_id'] : 'all'; 
		
		$result = $this->get_related_products_data($product_id, $variation_id , $start_date,$end_date);
		//wcpst_var_dump($result);
		echo json_encode($result);
		wp_die();
	}
	public function get_related_products_data($product_id, $variation_id ='all', $start_date = null, $end_date = null, $max_results_num = 'all')
	{
		$stats = $this->get_related_products($product_id, $variation_id , $start_date,$end_date);
		$result = array();
		
		/* Format:
		 [0]=>
			  array(3) {
				["total_purchases"]=>
				string(1) "3"
				["product_name"]=>
				string(29) "Product 4,Product 1,Product 2"
				["product_id"]=>
				string(8) "59,12,13"
			  }
			  [1]=>
			  array(3) {
				["total_purchases"]=>
				string(1) "1"
				["product_name"]=>
				string(9) "Product 2"
				["product_id"]=>
				string(2) "13"
			  }
			*/
		foreach((array)$stats as $stat)
		{
			$products = explode(",", $stat["product_name"]);
			$product_ids = explode(",", $stat["product_id"]);
			
			for($i = 0; $i < count($products); $i++)
			{
				if(!isset($result[$product_ids[$i]]))
					$result[$product_ids[$i]] = array("num_orders" => 1, "product_name" =>$products[$i], "product_id" => $product_ids[$i]);
				else
					$result[$product_ids[$i]]["num_orders"]++;
			}
		}
		if(!empty($result))
			usort($result, function($b, $a) {
					return $a['num_orders'] - $b['num_orders'];
				}); 
		
		return $result;
	}
	
	//shipping -> order item: order_item_type = "shipping", order_item_name = "Local Delivery"
	// order item meta: 
	public function get_related_products($product_id, $variation_id ='all', $start_date = null, $end_date = null, $max_results_num = 'all')
	{
		global $wpdb;
		$variation_join = "INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id ";
		$variation_where = " AND order_itemmeta_variation.meta_key = '_variation_id' ";
		$max_results_num = $max_results_num == 'all' ? "": " LIMIT ".$max_results_num;
		
		
		if((!isset($start_date) || $start_date == "") && (!isset($end_date) || $end_date == "")) { $start_date = date('Y-m-01'); $end_date = date('Y-m-t'); } 
		if($variation_id != 'all')
		{
			//$variation_join = " INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id  ";
			$variation_where = " AND order_itemmeta_variation.meta_value = {$variation_id} ";
		}
		
		$query_addons = $this->get_orders_query_conditions_to_exclude_bad_orders();
		
		$wpdb->query('SET SQL_BIG_SELECTS=1');
		$query = "SELECT COUNT(orders.id) AS total_purchases, GROUP_CONCAT(related_products.order_item_name) AS product_name, GROUP_CONCAT(related_productmeta.meta_value) AS product_id, GROUP_CONCAT(order_itemmeta_variation.meta_value) AS product_variation_id
				  FROM {$wpdb->posts} AS orders
				  INNER JOIN {$wpdb->prefix}woocommerce_order_items AS order_items ON order_items.order_id = orders.ID 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta ON order_itemmeta.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_items AS related_products ON related_products.order_id = orders.ID 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS related_productmeta ON related_products.order_item_id = related_productmeta.order_item_id 
				   {$variation_join} {$query_addons['join']} 
				  WHERE orders.post_type = 'shop_order' 				 
				  AND related_products.order_item_type = 'line_item' 
				  AND related_productmeta.meta_key = '_product_id' 
				  AND related_productmeta.meta_value != {$product_id} 
				  AND order_itemmeta.meta_key = '_product_id'
				  AND order_itemmeta.meta_value = {$product_id}  
				  AND orders.post_date >= '{$start_date} 00:00' 
				  AND orders.post_date <= '{$end_date} 23:59' {$variation_where} {$query_addons['where']}
				  GROUP BY orders.id";
			  
		return $wpdb->get_results($query, ARRAY_A);
	}	
	public function get_earnings_per_payment_method($product_id, $variation_id ='all', $start_date = null, $end_date = null, $max_results_num = 'all')
	{
		global $wpdb;
		$variation_join = " INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id  ";
		$variation_where = " AND order_itemmeta_variation.meta_key = '_variation_id' ";
		$max_results_num = $max_results_num == 'all' ? "": " LIMIT ".$max_results_num;
		
		
		if((!isset($start_date) || $start_date == "") && (!isset($end_date) || $end_date == "")) { $start_date = date('Y-m-01'); $end_date = date('Y-m-t'); } 
		if($variation_id != 'all')
		{
			//$variation_join = " INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id  ";
			$variation_where = " AND order_itemmeta_variation.meta_value = {$variation_id} ";
		}
		
		$query_addons = $this->get_orders_query_conditions_to_exclude_bad_orders();
		
		$wpdb->query('SET SQL_BIG_SELECTS=1');
		$wpdb->query('SET group_concat_max_len=50000'); 
		//SUM(order_total.meta_value)
		$query = "SELECT SUM(order_itemmeta_line_total.meta_value) AS total_earning, GROUP_CONCAT(order_itemmeta_qty.meta_value) AS total_purchases, payment_method.meta_value AS payment_method, payment_method_title.meta_value AS payment_method_title, GROUP_CONCAT(order_itemmeta_variation.meta_value) AS product_variation_id
				  FROM {$wpdb->posts} AS orders
				  INNER JOIN {$wpdb->prefix}woocommerce_order_items AS order_items ON order_items.order_id = orders.ID 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta ON order_itemmeta.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_line_total ON order_itemmeta_line_total.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_qty ON order_itemmeta_qty.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->postmeta} AS payment_method ON payment_method.post_id = orders.ID
				  INNER JOIN {$wpdb->postmeta} AS payment_method_title ON payment_method_title.post_id = orders.ID
				  INNER JOIN {$wpdb->postmeta} AS order_total ON order_total.post_id = orders.ID 
				  {$variation_join} {$query_addons['join']} 
				  WHERE orders.post_type = 'shop_order' 
				  AND order_total.meta_key = '_order_total' 
				  AND payment_method.meta_key = '_payment_method' 
				  AND payment_method_title.meta_key = '_payment_method_title' 
				  AND order_itemmeta.meta_key = '_product_id'
				  AND order_itemmeta_line_total.meta_key = '_line_total'			  
				  AND order_itemmeta_qty.meta_key = '_qty' 
				  AND order_itemmeta.meta_value = {$product_id}  
				  AND orders.post_date >= '{$start_date} 00:00' 
				  AND orders.post_date <= '{$end_date} 23:59' {$variation_where} {$query_addons['where']}
				  GROUP BY  payment_method.meta_value  ORDER BY order_total.meta_value ASC {$max_results_num}";
			  
		return $wpdb->get_results($query, ARRAY_A);
	}
	public function get_customers_per_period($product_id, $variation_id , $customers_num =  'all', $start_date = null, $end_date = null)
	{
		global $wpdb;
		$customers_num = $customers_num == 'all' ? "": " LIMIT ".$customers_num;
		$variation_join = " INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id ";
		$variation_where = " AND order_itemmeta_variation.meta_key = '_variation_id' ";
		
		if((!isset($start_date) || $start_date == "") && (!isset($end_date) || $end_date == "")) { $start_date = date('Y-m-01'); $end_date = date('Y-m-t'); } 
		
		if($variation_id != 'all')
		{
			//$variation_join = " INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id  ";
			$variation_where = " AND order_itemmeta_variation.meta_value = {$variation_id} ";
		}
		
		$query_addons = $this->get_orders_query_conditions_to_exclude_bad_orders();
		
		$wpdb->query('SET SQL_BIG_SELECTS=1');
		$wpdb->query('SET group_concat_max_len=50000'); 
		//SELECT SUM(total_spent.meta_value)
		$query = "SELECT SUM(order_itemmeta_line_total.meta_value) AS total_spent, COUNT(orders.id) AS order_num, customer_user_id.meta_value AS customer_id, GROUP_CONCAT(order_itemmeta_qty.meta_value) AS product_qty, GROUP_CONCAT(order_itemmeta_variation.meta_value) AS product_variation_id, 
							customer_email.meta_value AS customer_email, customer_user_name.meta_value AS name, customer_user_last_name.meta_value AS last_name
				  FROM {$wpdb->posts} AS orders
				  INNER JOIN {$wpdb->prefix}woocommerce_order_items AS order_items ON order_items.order_id = orders.ID 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta ON order_itemmeta.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_line_total ON order_itemmeta_line_total.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_qty ON order_itemmeta_qty.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->postmeta} AS customer_user_id ON customer_user_id.post_id = orders.ID 
				  INNER JOIN {$wpdb->postmeta} AS customer_user_name ON customer_user_name.post_id = orders.ID 
				  INNER JOIN {$wpdb->postmeta} AS customer_user_last_name ON customer_user_last_name.post_id = orders.ID 
				  INNER JOIN {$wpdb->postmeta} AS customer_email ON customer_email.post_id = orders.ID 
				  INNER JOIN {$wpdb->postmeta} AS total_spent ON total_spent.post_id = orders.ID 
				  {$variation_join} {$query_addons['join']}
				  WHERE orders.post_type = 'shop_order' 
				  AND order_itemmeta.meta_key = '_product_id' 
				  AND order_itemmeta_line_total.meta_key = '_line_total'			  
				  AND order_itemmeta_qty.meta_key = '_qty' 
				  AND order_itemmeta.meta_value = {$product_id} 
				  AND total_spent.meta_key = '_order_total' 
				  AND customer_user_id.meta_key = '_customer_user' 
				  AND customer_email.meta_key = '_billing_email' 
				  AND customer_user_name.meta_key = '_billing_first_name' 
				  AND customer_user_last_name.meta_key  = '_billing_last_name' ".
				  //AND customer_user_id.meta_value > 0 
				 " AND orders.post_date >= '{$start_date} 00:00' 
				  AND orders.post_date <= '{$end_date} 23:59'  {$variation_where} {$query_addons['where']} ".
				 // GROUP BY customer_user_id.meta_value  ORDER BY SUM(total_spent.meta_value) DESC LIMIT ".$customers_num;
				 " GROUP BY customer_email.meta_value  ORDER BY SUM(total_spent.meta_value) DESC ".$customers_num;
		
		$result = $wpdb->get_results($query, ARRAY_A);
		$result = isset($result) && !empty($result) ? $result : array();
		
		return $result;
	}
	public function get_earnings_per_period($product_id, $variation_id ='all', $range_type = 'daily', $start_date = null, $end_date = null)
	{
		global $wpdb;
		
		$group_by_string = "";
		$select_date_string = "";
		$variation_join = " INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id  ";
		$variation_where = " AND order_itemmeta_variation.meta_key = '_variation_id' ";
		
		switch($range_type)
		{
			case 'yearly':$group_by_string = "YEAR(orders.post_date)"; 
						   $select_date_string = "YEAR(orders.post_date)";
						   break;
			case 'monthly': $group_by_string = "YEAR(orders.post_date), MONTH(orders.post_date)";   //YEAR(record_date), MONTH(record_date)
							 $select_date_string = "concat_ws('/', MONTH(orders.post_date), YEAR(orders.post_date))";
							break;
			case 'daily' :  $group_by_string = "MONTH(orders.post_date), DAY(orders.post_date)"; 
						    $select_date_string = "concat_ws('/', DAY(orders.post_date), MONTH(orders.post_date), YEAR(orders.post_date))";
							break;
		}
		if((!isset($start_date) || $start_date == "") && (!isset($end_date) || $end_date == "")) { $start_date = date('Y-m-01'); $end_date = date('Y-m-t'); } 
		if($variation_id != 'all')
		{
			//$variation_join = " INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id  ";
			$variation_where = " AND order_itemmeta_variation.meta_value = {$variation_id} ";
		}
		
		$query_addons = $this->get_orders_query_conditions_to_exclude_bad_orders();
		$variation = "";////AND order_itemmeta.meta_key = '_variation_id'
		
		$wpdb->query('SET SQL_BIG_SELECTS=1');
		$wpdb->query('SET group_concat_max_len=50000'); 
		$query = "SELECT SUM(order_itemmeta_total.meta_value) AS product_total, {$select_date_string} AS date, GROUP_CONCAT(order_itemmeta_qty.meta_value) AS product_qty, GROUP_CONCAT(order_itemmeta_variation.meta_value) AS product_variation_id ".//, GROUP_CONCAT(orders.ID) AS orders_id , SUM(order_itemmeta.meta_value) AS total_items
				 " FROM {$wpdb->posts} AS orders
				  INNER JOIN {$wpdb->postmeta} AS order_total ON order_total.post_id = orders.ID 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_items AS order_items ON order_items.order_id = orders.ID 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta ON order_itemmeta.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_total ON order_itemmeta_total.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_qty ON order_itemmeta_qty.order_item_id = order_items.order_item_id 
				  {$variation_join} {$query_addons['join']} 
				  WHERE orders.post_type = 'shop_order' 
				  AND order_total.meta_key = '_order_total' 
				  AND order_items.order_item_type = 'line_item' 
				  AND order_itemmeta.meta_key = '_product_id' 
				  AND order_itemmeta_total.meta_key = '_line_total' 
				  AND order_itemmeta_qty.meta_key = '_qty' 
				  AND order_itemmeta.meta_value = {$product_id}  
				  AND orders.post_date >= '{$start_date} 00:00' 
				  AND orders.post_date <= '{$end_date} 23:59'  {$variation_where} {$query_addons['where']} 
				  GROUP BY  ".$group_by_string;
			  
			  
		return $wpdb->get_results($query, ARRAY_A);
	}
	public function get_quantities($order_ids)
	{
		global $wpdb;
		$query = "SELECT SUM(order_itemmeta.meta_value) AS total_items 
				  FROM {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta
				  INNER JOIN {$wpdb->prefix}woocommerce_order_items AS order_items ON order_items.order_item_id = order_itemmeta.order_item_id
				  WHERE order_items.order_item_type = 'line_item'
				  AND order_itemmeta.meta_key = '_qty'	
				  AND order_items.order_id IN({$order_ids})";
		$result = $wpdb->get_col($query);
		return isset($result) ? $result[0]:0;
	}
	public function get_earnings_per_geographic_area($product_id, $variation_id ='all', $area_type = 'country', $start_date = null, $end_date = null, $max_results_num = 'all')
	{
		global $wpdb;
		
		$group_by_string = "";
		$select_zone_string = "";
		$geographic_join = "";
		$geographic_condition = "";
		$variation_join = " INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id ";
		$variation_where = " AND order_itemmeta_variation.meta_key = '_variation_id' ";
		$max_results_num = $max_results_num == 'all' ? "": " LIMIT ".$max_results_num;
		
		switch($area_type)
		{
			case 'country':$group_by_string = " billing_country.meta_value "; 
						   $select_zone_string = " billing_country.meta_value ";
						   $geographic_join = " INNER JOIN {$wpdb->postmeta} AS billing_country ON billing_country.post_id = orders.ID  ";
						   $geographic_condition = " AND billing_country.meta_key = '_billing_country' ";
						   break;
			case 'state': $group_by_string = " billing_state.meta_value "; 
						  $select_zone_string = " billing_state.meta_value ";
						  $geographic_join = " INNER JOIN {$wpdb->postmeta} AS billing_state ON billing_state.post_id = orders.ID  ";
						  $geographic_condition = " AND billing_state.meta_key = '_billing_state' ";
						  break;
			case 'city': $group_by_string = " billing_city.meta_value  ";   
						 $select_zone_string = " billing_city.meta ";
						 $geographic_join = " INNER JOIN {$wpdb->postmeta} AS billing_city ON billing_city.post_id = orders.ID  ";
						 $geographic_condition = " AND billing_city.meta_key = '_billing_city' ";
					     break;
		}
		if((!isset($start_date) || $start_date == "") && (!isset($end_date) || $end_date == "")) { $start_date = date('Y-m-01'); $end_date = date('Y-m-t'); } 
		if($variation_id != 'all')
		{
			//$variation_join = " INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_variation ON order_itemmeta_variation.order_item_id = order_items.order_item_id  ";
			$variation_where = " AND order_itemmeta_variation.meta_value = {$variation_id} ";
		}
		
		$query_addons = $this->get_orders_query_conditions_to_exclude_bad_orders();
		
		$wpdb->query('SET SQL_BIG_SELECTS=1');
		$wpdb->query('SET group_concat_max_len=50000'); 
		//SUM(order_total.meta_value)
		//COUNT(orders.id) AS total_purchases,
		$query = "SELECT SUM(order_itemmeta_line_total.meta_value) AS total_earning, {$select_zone_string} as zone_name,  GROUP_CONCAT(order_itemmeta_qty.meta_value) AS total_purchases, GROUP_CONCAT(order_itemmeta_variation.meta_value) AS product_variation_id
				  FROM {$wpdb->posts} AS orders
				  INNER JOIN {$wpdb->prefix}woocommerce_order_items AS order_items ON order_items.order_id = orders.ID 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta ON order_itemmeta.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_line_total ON order_itemmeta_line_total.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_itemmeta_qty ON order_itemmeta_qty.order_item_id = order_items.order_item_id 
				  INNER JOIN {$wpdb->postmeta} AS order_total ON order_total.post_id = orders.ID {$variation_join} {$query_addons['join']} {$geographic_join}
				  WHERE orders.post_type = 'shop_order' {$geographic_condition}
				  AND order_total.meta_key = '_order_total' 
				  AND order_itemmeta_line_total.meta_key = '_line_total'
				  AND order_itemmeta.meta_key = '_product_id'
				  AND order_itemmeta.meta_value = {$product_id}  
				  AND order_itemmeta_qty.meta_key = '_qty' 
				  AND orders.post_date >= '{$start_date} 00:00' 
				  AND orders.post_date <= '{$end_date} 23:59' {$variation_where} {$query_addons['where']}
				  GROUP BY  ".$group_by_string. "  ORDER BY order_total.meta_value ASC {$max_results_num}";
			  
		return $wpdb->get_results($query, ARRAY_A);
	}
	public function get_first_order_by_period($period = 'year')
	{
		global $wpdb;
		$query = "SELECT orders.post_date 
				 FROM {$wpdb->posts} AS orders
				 WHERE orders.post_type = 'shop_order' 
				 ORDER BY orders.post_date ASC LIMIT 1";
		$result = $wpdb->get_results($query);
		return isset($result) && isset($result[0]) ? $result[0]->post_date : false;
	}
	public function get_orders_query_conditions_to_exclude_bad_orders($join_type = 'INNER')
	{
		global $wpdb;
		$statuses = $this->get_order_statuses();
		$result = array();
		$result['join'] = "";
		$result['where'] = "";
		$result['version'] = $statuses['version'];
		if($statuses['version'] > 2.1)
		{
			$result['statuses'] = $statuses['statuses'] = array_diff($statuses['statuses'], array('wc-cancelled', 'wc-refunded', 'wc-failed'));
			$result['where'] = " AND orders.post_status IN ('".implode( "','",$statuses['statuses'])."') ";
		}
		else 
		{
			$result['statuses'] = $statuses['statuses'] = array_diff($statuses['statuses'], array('cancelled', 'refunded', 'failed'));
			$result['join'] = " {$join_type} JOIN {$wpdb->term_relationships} AS rel ON orders.ID=rel.object_id
							  {$join_type} JOIN {$wpdb->term_taxonomy} AS tax ON tax.term_taxonomy_id = rel.term_taxonomy_id
							  {$join_type} JOIN {$wpdb->terms} AS term ON term.term_id = tax.term_id ";
			$result['where'] .= " AND orders.post_status   = 'publish'
								 AND tax.taxonomy        = 'shop_order_status' 
								 AND term.slug           IN ( '" .implode( "','",$statuses['statuses']). "' )";
		}
		
		return $result;
	}
	public function get_order_statuses()
	{
		
		$result = array();
		$result['statuses'] = array();
		if(function_exists( 'wc_get_order_statuses' ))
		{
			
			$result['version'] = 2.2;
			//[slug] => name
			$temp  = wc_get_order_statuses();
			foreach($temp as $slug => $title)
					array_push($result['statuses'], $slug);
		}
		else
		{
			$args = array(
				'hide_empty'   => false, 
				'fields'            => 'id=>slug', 
			);
			$result['version'] = 2.1;
			
			$temp = get_terms('shop_order_status', $args);
			foreach($temp as $id => $slug)
					array_push($result['statuses'], $slug);
		}
		return $result;
	}
}
?>