<?php 
class WCPST_ProductPage
{
	public function __construct()
	{
		add_filter('woocommerce_related_products_args', array(&$this, 'compute_related'), 10); 
	}
	
	function compute_related($args)
	{
		 global $wcpst_order_model, $wcpst_options, $wcpst_wpml_helper;
		$general_options = $wcpst_options->get_general_options();
		$current_product_id = get_the_ID();
		if(!$current_product_id || $general_options['disable_default_related_list_override'] == 'yes')
			return $args;
		$current_product_id = $wcpst_wpml_helper->get_original_id($current_product_id);
		
		$max_result = $args['posts_per_page'];
		$related = $wcpst_order_model->get_related_products_data($current_product_id, 'all', date('Y-m-01', strtotime('-'.$general_options['time_span_for_related_computation'].' month')), date('Y-m-t'));
		if($max_result == 0 || (empty($related) && $general_options['if_the_computed_related_list_is_empty'] == 'empty'))
			return array();
		else if(empty($related) && $general_options['if_the_computed_related_list_is_empty'] != 'empty')
			return $args;
		
		//wcpst_var_dump($related);
		$args["post__in"] = array();
		$args["orderby"] = "post__in";
		foreach((array)$related as $related_product)
		{
			$args["post__in"][] = $related_product['product_id'];
			if(--$max_result == 0)
				break;
		}
		//wcpst_var_dump($args);
		return $args;
	}
}
?>