var Earning_per_period_chart = function(myId, product_id, widget_contaniner_unique_id)
{
	this.myId = myId;
	this.widget_contaniner_unique_id = widget_contaniner_unique_id;
	
	this.product_id = product_id;
	this.wcpst_geographic_chart_labels =[];
	this.wcpst_geographic_total_earnings = [];
	this.wcpst_geographic_count_per_date = [];	
	this.wcpst_earning_chart_labels =[];
	this.wcpst_total_earnings = [];
	this.wcpst_count_per_date = [];
	this.wcpst_count_items_per_date = [];
	this.wcpst_earning_widget_picker_start_date;
	this.wcpst_earning_widget_picker_end_date;
	this.wcpst_earning_widget_start_date;
	this.wcpst_earning_widget_end_date;
	this.wcpst_stat_table;
	
	var mySelf = this;
	jQuery('#wcpst_date_filter_button_'+this.widget_contaniner_unique_id).click(function(){ mySelf.wcpst_start_reloading_earning_widget_data();});
	jQuery('#wcpst_earnings_chart_filter_by_view_type_button_'+this.myId).click(function(){ mySelf.wcpst_start_reloading_earning_widget_data();});
	this.wcpst_set_range_date_selectors();
	this.wcpst_start_reloading_earning_widget_data(null);
}

Earning_per_period_chart.prototype.wcpst_start_reloading_earning_widget_data = function(event)
{
	var mySelf = this;
	if(event != null)
	{
		event.stopImmediatePropagation();
		event.preventDefault();
	}
	
	if(!this.wcpst_earning_widget_are_date_good())
		alert(wcpst_date_error);
	else
	{
		jQuery('#wcpst_earning_wait_box_'+this.myId).fadeIn(500);
		jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).fadeOut(500);
		jQuery('#wcpst_change_view_container_'+this.myId).fadeOut(200);
		jQuery('#wcpst_earning_stats_table_'+this.myId).delay(600).fadeOut(300, function(){ mySelf.wcpst_reset_earning_widget_canvas(); mySelf.wcpst_load_new_earnings_widget_data()});
	}
}
Earning_per_period_chart.prototype.wcpst_load_new_earnings_widget_data = function()
{
	var mySelf = this;
	var formData = new FormData();
	wcpst_earning_widget_date_range_type = jQuery('#wcpst_earning_period_range_'+this.myId).val();
	formData.append('action', 'wcpst_earning_widget_get_earning_per_period');
	formData.append('start_date', this.wcpst_earning_widget_start_date);
	formData.append('end_date', this.wcpst_earning_widget_end_date);
	formData.append('view_type', wcpst_earning_widget_date_range_type);
	formData.append('product_id', this.product_id );
	formData.append('variation_id', jQuery('#wcpst_variation_id_'+this.myId).val() );
	
	jQuery.ajax({
		url: ajaxurl, 
		type: 'POST',
		data: formData,
		async: true,
		success: function (data) 
		{
			mySelf.wcpst_refresh_earning_widget(data);
		},
		error: function (data,error) 
		{
			/* console.log(data);
			console.log(error); */
			//alert("Could not contact the server, Error message: "+error);
		},
		cache: false,
		contentType: false, 
		processData: false
	});
}
//Chart
Earning_per_period_chart.prototype.wcpst_refresh_earning_widget = function(data)
{
	var mySelf = this;
	var result = jQuery.parseJSON(data); //.dates ; .totals ; .order_num
	
	/* console.log(data);
	console.log(result); */
	
	this.wcpst_earning_chart_labels = result.dates.split(",");
	this.wcpst_total_earnings = result.totals.split(",");
	//this.wcpst_count_per_date = result.order_num.split(",");
	this.wcpst_count_items_per_date = result.quantities.split(",");
	
	//this.wcpst_earning_clear_table();
	jQuery('#wcpst_earning_wait_box_'+this.myId).fadeOut(300);
	jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).delay(300).fadeIn(500);
	jQuery('#wcpst_change_view_container_'+this.myId).delay(300).fadeIn(500);
	jQuery('#wcpst_earning_stats_table_'+this.myId).delay(300).fadeIn(500, function() {mySelf.wcpst_create_earning_chart();});
}
Earning_per_period_chart.prototype.wcpst_create_earning_chart = function()
{
	var wcpst_line_chart_data = 
		{
			labels : this.wcpst_earning_chart_labels,
			datasets : 
			[
				{
					//label: "label",
					fillColor: "rgba(164, 100, 151, 0.2)",
					strokeColor: "rgba(164, 100, 151, 1)",
					highlightFill: "rgba(164, 100, 151, 0.75)",
					highlightStroke: "rgba(164, 100, 151, 1)",
					data: this.wcpst_total_earnings
				}
			]
		};
						
	ctx = jQuery('#wcpst_earning_stats_'+this.myId).get(0).getContext("2d");
	var myLineChart = new Chart(ctx).Line(wcpst_line_chart_data, {responsive : true, pointHitDetectionRadius:5}); //default 20
	this.wcpst_render_table();
}
//End chart

//Table
Earning_per_period_chart.prototype.wcpst_render_table = function()
{
	var total_earnings = total_count = total_items_count = 0;
	var html_string = "";
	if(this.wcpst_total_earnings != "")
		for(var i=0; i<this.wcpst_total_earnings.length; i++)
		{
			html_string += '<tr class="wcpst_table_row">';
			html_string += '<td>'+this.wcpst_earning_chart_labels[i]+'</td>';
			html_string += '<td class="wcpst_product_title_column"><span class="wcpst_table_long_text ">'+this.wcpst_count_items_per_date[i]+'</span></td>';
			//html_string += '<td>'+this.wcpst_count_per_date[i]+'</td>';
			html_string += '<td>'+this.wcpst_total_earnings[i]+wcpst_currency+'</td>';
			html_string += '</tr>';
				
			total_earnings += parseFloat(this.wcpst_total_earnings[i]);
			//total_count += parseInt(this.wcpst_count_per_date[i]);
			total_items_count += parseInt(this.wcpst_count_items_per_date[i]);
		}
		
	jQuery("#wcpst_table_body_"+this.myId).html(html_string);
	this.wcpst_stat_table = jQuery('#wcpst_product_table_'+this.myId).DataTable( 
					{
						"aLengthMenu": [[5, 10, 15, 25, 50, 75, -1], [5, 10, 15, 25, 50, 75, "All"]],
						"pagingType": "full_numbers",
						 "pageLength": 10,
						 "order": [[ 1, "desc" ]],
						 "aoColumnDefs": [
							  { 'bSortable': false  /* , 'aTargets': [ unsorable_colum ] */  }
						   ]
					} );
			
	//jQuery('#wcpst_foot_total_count_'+this.myId).html(parseFloat(total_count));
	jQuery('#wcpst_products_foot_total_item_count_'+this.myId).html(total_items_count);
	jQuery('#wcpst_foot_total_earnings_'+this.myId).html(parseFloat(total_earnings).toFixed(2)+wcpst_currency);
	
}

//Misc
Earning_per_period_chart.prototype.wcpst_earning_clear_table = function()
{
	if(this.wcpst_stat_table)
		this.wcpst_stat_table.destroy();
	jQuery('#wcpst_table_body_'+this.myId).empty();
}
Earning_per_period_chart.prototype.wcpst_set_range_date_selectors = function()
{
	//if(selector_type == 'daily')
	{
		this.wcpst_earning_widget_picker_start_date = jQuery( '#wcpst_earning_picker_start_date_'+this.widget_contaniner_unique_id ).pickadate({selectMonths: true, selectYears: true, trueformatSubmit: 'yyyy-mm-dd', format: 'yyyy/mm/dd'});
		this.wcpst_earning_widget_picker_end_date = jQuery( '#wcpst_earning_picker_end_date_'+this.widget_contaniner_unique_id ).pickadate({selectMonths: true, selectYears: true, formatSubmit: 'yyyy-mm-dd', format: 'yyyy/mm/dd'});
	}
}
Earning_per_period_chart.prototype.wcpst_earning_widget_are_date_good = function()
{
	var picker_start_date = this.wcpst_earning_widget_picker_start_date.pickadate('picker');
	var picker_end_date = this.wcpst_earning_widget_picker_end_date.pickadate('picker'); 
	
	//if(wcpst_earning_widget_date_range_type == 'daily')
	{
		this.wcpst_earning_widget_start_date = picker_start_date.get('select', 'yyyy-mm-dd'); 
		this.wcpst_earning_widget_end_date = picker_end_date.get('select', 'yyyy-mm-dd');
	}
	if(this.wcpst_earning_widget_start_date > this.wcpst_earning_widget_end_date)
		return false;
	
	return true;
}
Earning_per_period_chart.prototype.wcpst_reset_earning_widget_canvas = function()
{
	this.wcpst_earning_clear_table();
	jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).empty();
	jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).append('<canvas id="wcpst_earning_stats_'+this.myId+'" ></canvas>');
}
