var Earning_geo_per_period_chart = function(myId, product_id, widget_contaniner_unique_id)
{
	this.myId = myId;
	this.widget_contaniner_unique_id = widget_contaniner_unique_id;
	
	this.product_id = product_id;
	this.wcpst_geographic_chart_labels =[];
	this.wcpst_geographic_total_earnings = [];
	this.wcpst_geographic_count_per_date = [];	
	this.wcpst_geographic_data = {};	
	this.wcpst_earning_widget_picker_start_date;
	this.wcpst_earning_widget_picker_end_date;
	this.wcpst_earning_widget_start_date;
	this.wcpst_earning_widget_end_date;
	this.wcpst_stat_table;
	
	var mySelf = this;
	jQuery('#wcpst_date_filter_button_'+this.widget_contaniner_unique_id).click(function(){ mySelf.wcpst_start_reloading_earning_widget_data();});
	jQuery('#wcpst_earnings_chart_filter_by_view_type_button_'+this.myId).click(function(){ mySelf.wcpst_start_reloading_earning_widget_data();});
	this.wcpst_set_range_date_selectors();
	this.wcpst_start_reloading_earning_widget_data(null);
}

Earning_geo_per_period_chart.prototype.wcpst_start_reloading_earning_widget_data = function(event)
{
	var mySelf = this;
	if(event != null)
	{
		event.stopImmediatePropagation();
		event.preventDefault();
	}
	
	if(!this.wcpst_earning_widget_are_date_good())
		alert(wcpst_date_error);
	else
	{
		jQuery('#wcpst_earning_wait_box_'+this.myId).fadeIn(500);
		jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).fadeOut(500);
		jQuery('#wcpst_change_view_container_'+this.myId).fadeOut(200);
		jQuery('#wcpst_earning_stats_table_'+this.myId).delay(600).fadeOut(300, function(){ mySelf.wcpst_reset_earning_widget_canvas(); mySelf.wcpst_load_new_earnings_widget_data()});
	}
}
Earning_geo_per_period_chart.prototype.wcpst_load_new_earnings_widget_data = function()
{
	var mySelf = this;
	var formData = new FormData();
	formData.append('action', 'wcpst_geographic_widget_get_earning_per_area');
	formData.append('start_date', this.wcpst_earning_widget_start_date);
	formData.append('end_date', this.wcpst_earning_widget_end_date);
	formData.append('view_type',  jQuery("#wcpst_geographic_view_type_"+this.myId).val() );
	formData.append('product_id', this.product_id );
	formData.append('variation_id', jQuery('#wcpst_variation_id_'+this.myId).val() );
	
	jQuery.ajax({
		url: ajaxurl, 
		type: 'POST',
		data: formData,
		async: true,
		success: function (data) 
		{
			mySelf.wcpst_refresh_earning_widget(data);
		},
		error: function (data,error) 
		{
			/* console.log(data);
			console.log(error); */
			//alert("Could not contact the server, Error message: "+error);
		},
		cache: false,
		contentType: false, 
		processData: false
	});
}
//Chart
Earning_geo_per_period_chart.prototype.wcpst_refresh_earning_widget = function(data)
{
	var mySelf = this;
	this.wcpst_geographic_data = jQuery.parseJSON(data); //.dates ; .totals ; .order_num
	
	/* console.log(data);
	console.log(result); 
	return;*/
	
	
	//this.wcpst_earning_clear_table();
	jQuery('#wcpst_earning_wait_box_'+this.myId).fadeOut(300);
	jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).delay(300).fadeIn(500);
	jQuery('#wcpst_change_view_container_'+this.myId).delay(300).fadeIn(500);
	jQuery('#wcpst_earning_stats_table_'+this.myId).delay(300).fadeIn(500, function() {mySelf.wcpst_create_earning_chart();});
}
Earning_geo_per_period_chart.prototype.wcpst_create_earning_chart = function()
{
	var labels_array = new Array();
	var data_array = new Array();
	
	jQuery.each(this.wcpst_geographic_data,function(index, product)
	{
		labels_array.push(product.zone_name);
		data_array.push(parseFloat(product.total_earning));
	});
	var wcpst_geographic_chart_data = {
		labels:labels_array,
		datasets:[{
					label: "Zones",
					fillColor: "rgba(164, 100, 151, 0.2)",
					strokeColor: "rgba(164, 100, 151, 1)",
					pointColor: "rgba(164, 100, 151, 1)",
					pointStrokeColor: "#fff",
					pointHighlightFill: "#fff",
					pointHighlightStroke: "rgba(220,220,220,1)",
					data: data_array
				}]
	};
	
	ctx = jQuery('#wcpst_earning_stats_'+this.myId).get(0).getContext("2d");
	var myChart = new Chart(ctx).Radar(wcpst_geographic_chart_data, {responsive : true, pointHitDetectionRadius:5}); //default 20

	this.wcpst_render_table();
}
//End chart

//Table
Earning_geo_per_period_chart.prototype.wcpst_render_table = function()
{
	var total_earnings = total_count = total_items_count = 0;
	var html_string = "";
	var total_earnings = total_count = 0;
	var name = '';
	var mySelf = this;
	jQuery.each(this.wcpst_geographic_data,function(index, product)
	{
		if(product != null)
		{
			name = product.zone_name;
			if(jQuery('#wcpst_geographic_view_type_'+mySelf.myId).val() === 'country')
				name = '<img src="'+wcpst_flags_path+product.zone_code+'.png" /> '+name;
			
			html_string += "<tr class=\"wcpst_table_row\">"+
								"<td>"+name+"</td>"+
								"<td>"+product.total_purchases+"</td>"+
								"<td>"+product.total_earning+wcpst_currency+"</td>"+
							"</tr>";
			if(product.total_earning != null)
				total_earnings += parseFloat(product.total_earning);
			if(product.total_purchases != null)
				total_count += parseInt(product.total_purchases);
		}
	});
	
	jQuery("#wcpst_table_body_"+this.myId).html(html_string);
	this.wcpst_stat_table = jQuery('#wcpst_product_table_'+this.myId).DataTable( 
					{
						"aLengthMenu": [[5, 10, 15, 25, 50, 75, -1], [5, 10, 15, 25, 50, 75, "All"]],
						"pagingType": "full_numbers",
						 "pageLength": 10,
						 "order": [[ 1, "desc" ]],
						 "aoColumnDefs": [
							  { 'bSortable': false  /* , 'aTargets': [ unsorable_colum ] */  }
						   ]
					} );
			
	jQuery('#wcpst_geographic_foot_total_count_'+this.myId).html(parseFloat(total_count));
	jQuery('#wcpst_geographic_foot_total_earnings_'+this.myId).html(parseFloat(total_earnings).toFixed(2)+wcpst_currency);
	
}

//Misc
Earning_geo_per_period_chart.prototype.wcpst_earning_clear_table = function()
{
	if(this.wcpst_stat_table)
		this.wcpst_stat_table.destroy();
	jQuery('#wcpst_table_body_'+this.myId).empty();
}
Earning_geo_per_period_chart.prototype.wcpst_set_range_date_selectors = function()
{
	//if(selector_type == 'daily')
	{
		this.wcpst_earning_widget_picker_start_date = jQuery( '#wcpst_earning_picker_start_date_'+this.widget_contaniner_unique_id ).pickadate({selectMonths: true, selectYears: true, trueformatSubmit: 'yyyy-mm-dd', format: 'yyyy/mm/dd'});
		this.wcpst_earning_widget_picker_end_date = jQuery( '#wcpst_earning_picker_end_date_'+this.widget_contaniner_unique_id ).pickadate({selectMonths: true, selectYears: true, formatSubmit: 'yyyy-mm-dd', format: 'yyyy/mm/dd'});
	}
}
Earning_geo_per_period_chart.prototype.wcpst_earning_widget_are_date_good = function()
{
	var picker_start_date = this.wcpst_earning_widget_picker_start_date.pickadate('picker');
	var picker_end_date = this.wcpst_earning_widget_picker_end_date.pickadate('picker'); 
	
	//if(wcpst_earning_widget_date_range_type == 'daily')
	{
		this.wcpst_earning_widget_start_date = picker_start_date.get('select', 'yyyy-mm-dd'); 
		this.wcpst_earning_widget_end_date = picker_end_date.get('select', 'yyyy-mm-dd');
	}
	if(this.wcpst_earning_widget_start_date > this.wcpst_earning_widget_end_date)
		return false;
	
	return true;
}
Earning_geo_per_period_chart.prototype.wcpst_reset_earning_widget_canvas = function()
{
	this.wcpst_earning_clear_table();
	jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).empty();
	jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).append('<canvas id="wcpst_earning_stats_'+this.myId+'" ></canvas>');
}
