var Products_related_per_period_chart = function(myId, product_id, widget_contaniner_unique_id)
{
	this.myId = myId;
	this.widget_contaniner_unique_id = widget_contaniner_unique_id;
	
	this.product_id = product_id;
	this.wcpst_geographic_chart_labels =[];
	this.wcpst_geographic_total_earnings = [];
	this.wcpst_geographic_count_per_date = [];	
	this.wcpst_response_data = {};	
	this.wcpst_earning_widget_picker_start_date;
	this.wcpst_earning_widget_picker_end_date;
	this.wcpst_earning_widget_start_date;
	this.wcpst_earning_widget_end_date;
	this.wcpst_stat_table;
	
	var mySelf = this;
	jQuery('#wcpst_date_filter_button_'+this.widget_contaniner_unique_id).click(function(){ mySelf.wcpst_start_reloading_earning_widget_data();});
	jQuery('#wcpst_earnings_chart_filter_by_view_type_button_'+this.myId).click(function(){ mySelf.wcpst_start_reloading_earning_widget_data();});
	this.wcpst_set_range_date_selectors();
	this.wcpst_start_reloading_earning_widget_data(null);
}

Products_related_per_period_chart.prototype.wcpst_start_reloading_earning_widget_data = function(event)
{
	var mySelf = this;
	if(event != null)
	{
		event.stopImmediatePropagation();
		event.preventDefault();
	}
	
	if(!this.wcpst_earning_widget_are_date_good())
		alert(wcpst_date_error);
	else
	{
		jQuery('#wcpst_earning_wait_box_'+this.myId).fadeIn(500);
		jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).fadeOut(500);
		jQuery('#wcpst_change_view_container_'+this.myId).fadeOut(200);
		jQuery('#wcpst_earning_stats_table_'+this.myId).delay(600).fadeOut(300, function(){ mySelf.wcpst_reset_earning_widget_canvas(); mySelf.wcpst_load_new_earnings_widget_data()});
	}
}
Products_related_per_period_chart.prototype.wcpst_load_new_earnings_widget_data = function()
{
	var mySelf = this;
	var formData = new FormData();
	formData.append('action', 'wcpst_products_related');
	formData.append('start_date', this.wcpst_earning_widget_start_date);
	formData.append('end_date', this.wcpst_earning_widget_end_date);
	formData.append('product_id', this.product_id );
	formData.append('variation_id', jQuery('#wcpst_variation_id_'+this.myId).val() );
	
	jQuery.ajax({
		url: ajaxurl, 
		type: 'POST',
		data: formData,
		async: true,
		success: function (data) 
		{
			mySelf.wcpst_refresh_earning_widget(data);
		},
		error: function (data,error) 
		{
			/* console.log(data);
			console.log(error); */
			//alert("Could not contact the server, Error message: "+error);
		},
		cache: false,
		contentType: false, 
		processData: false
	});
}
//Chart
Products_related_per_period_chart.prototype.wcpst_refresh_earning_widget = function(data)
{
	var mySelf = this;
	this.wcpst_response_data = jQuery.parseJSON(data); //.dates ; .totals ; .order_num
	
	/* console.log(data);
	console.log(this.wcpst_response_data); 
	return;*/
	
	
	//this.wcpst_earning_clear_table();
	jQuery('#wcpst_earning_wait_box_'+this.myId).fadeOut(300);
	jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).delay(300).fadeIn(500);
	jQuery('#wcpst_change_view_container_'+this.myId).delay(300).fadeIn(500);
	jQuery('#wcpst_earning_stats_table_'+this.myId).delay(300).fadeIn(500, function() {mySelf.wcpst_create_earning_chart();});
}
Products_related_per_period_chart.prototype.wcpst_create_earning_chart = function()
{
	wcpst_chart_data = new Array();
	var mySelf = this;
	
	jQuery.each(this.wcpst_response_data,function(index, related)
	{
		wcpst_chart_data.push(
		{
			value: parseInt(related.num_orders),
			color: mySelf.wcpst_getRandomColor(),
			highlight: "#a46497",
			label: related.product_name
		});
	});
	
	ctx = jQuery('#wcpst_earning_stats_'+this.myId).get(0).getContext("2d");
	var myPolarAreaChart = new Chart(ctx).Pie(wcpst_chart_data, {responsive : true}); 
	
	this.wcpst_render_table();
}
//End chart

//Table
Products_related_per_period_chart.prototype.wcpst_render_table = function()
{
	var total_count = 0;
	var is_guest, user_link;
	var html_string = "";
	
	jQuery.each(this.wcpst_response_data,function(index, related)
	{
		html_string +="<tr class=\"wcpst_table_row\">"+
						"<td>"+related.product_id+"</td>"+
						"<td>"+related.product_name+"</td>"+
						"<td>"+related.num_orders+"</td>"+
					"</tr>";
		
		total_count += parseInt(related.num_orders);
	});	
	
	jQuery("#wcpst_table_body_"+this.myId).html(html_string);
	this.wcpst_stat_table = jQuery('#wcpst_product_table_'+this.myId).DataTable( 
					{
						"aLengthMenu": [[5, 10, 15, 25, 50, 75, -1], [5, 10, 15, 25, 50, 75, "All"]],
						"pagingType": "full_numbers",
						 "pageLength": 10,
						 "order": [[ 2, "desc" ]],
						 "aoColumnDefs": [
							  { 'bSortable': false  /* , 'aTargets': [ unsorable_colum ] */  }
						   ]
					} );
			
	jQuery('#wcpst_foot_total_orders_'+this.myId).html(parseFloat(total_count));
	
}

//Misc
Products_related_per_period_chart.prototype.wcpst_earning_clear_table = function()
{
	if(this.wcpst_stat_table)
		this.wcpst_stat_table.destroy();
	jQuery('#wcpst_table_body_'+this.myId).empty();
}
Products_related_per_period_chart.prototype.wcpst_set_range_date_selectors = function()
{
	//if(selector_type == 'daily')
	{
		this.wcpst_earning_widget_picker_start_date = jQuery( '#wcpst_earning_picker_start_date_'+this.widget_contaniner_unique_id ).pickadate({selectMonths: true, selectYears: true, trueformatSubmit: 'yyyy-mm-dd', format: 'yyyy/mm/dd'});
		this.wcpst_earning_widget_picker_end_date = jQuery( '#wcpst_earning_picker_end_date_'+this.widget_contaniner_unique_id ).pickadate({selectMonths: true, selectYears: true, formatSubmit: 'yyyy-mm-dd', format: 'yyyy/mm/dd'});
	}
}
Products_related_per_period_chart.prototype.wcpst_earning_widget_are_date_good = function()
{
	var picker_start_date = this.wcpst_earning_widget_picker_start_date.pickadate('picker');
	var picker_end_date = this.wcpst_earning_widget_picker_end_date.pickadate('picker'); 
	
	//if(wcpst_earning_widget_date_range_type == 'daily')
	{
		this.wcpst_earning_widget_start_date = picker_start_date.get('select', 'yyyy-mm-dd'); 
		this.wcpst_earning_widget_end_date = picker_end_date.get('select', 'yyyy-mm-dd');
	}
	if(this.wcpst_earning_widget_start_date > this.wcpst_earning_widget_end_date)
		return false;
	
	return true;
}
Products_related_per_period_chart.prototype.wcpst_reset_earning_widget_canvas = function()
{
	this.wcpst_earning_clear_table();
	jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).empty();
	jQuery('#wcpst_earning_stats_canvas_box_'+this.myId).append('<canvas id="wcpst_earning_stats_'+this.myId+'" ></canvas>');
}
Products_related_per_period_chart.prototype.wcpst_getRandomColor = function() 
{
	var letters = '0123456789ABCDEF'.split('');
	var color = '#';
	for (var i = 0; i < 6; i++ ) {
		color += letters[Math.floor(Math.random() * 16)];
	}
	return color;
}
