<?php 
/*
Plugin Name: WooCommerce Product Stats and Related!
Description: Product stats and related products.
Author: Lagudi Domenico
Version: 2.8
*/

/* 
Copyright: WooCommerce Product Stats uses the ACF PRO plugin. ACF PRO files are not to be used or distributed outside of the WooCommerce Product Stats plugin.
*/

//define('WCPST_PLUGIN_URL', WP_PLUGIN_URL."/".dirname( plugin_basename( __FILE__ ) ) );
define('WCPST_PLUGIN_URL', rtrim(plugin_dir_url(__FILE__), "/") ) ;
define('WCPST_PLUGIN_ABS_PATH', dirname( __FILE__ ) );

if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) 
{
	include_once( "classes/com/WCPST_Acf.php");
	
	load_plugin_textdomain('woocommerce-product-stats', false, basename( dirname( __FILE__ ) ) . '/languages' );
	
	if(!class_exists('WCPST_Html.php'))
		require_once('classes/com/WCPST_Html.php');
	$wcpst_html_helper = new WCPST_Html(); 
	
	if(!class_exists('WCPST_Wpml.php'))
		require_once('classes/com/WCPST_Wpml.php');
	$wcpst_wpml_helper = new WCPST_Wpml();
	
	if(!class_exists('WCPST_Product.php'))
		require_once('classes/com/WCPST_Product.php');
	$wcpst_product_model = new WCPST_Product();
	
	if(!class_exists('WCPST_Order.php'))
		require_once('classes/com/WCPST_Order.php');
	$wcpst_order_model = new WCPST_Order();
	
	if(!class_exists('WCPST_ProductsListPage.php'))
		require_once('classes/admin/WCPST_ProductsListPage.php');
	$wcpst_productList_page = new WCPST_ProductsListPage(); 
	
	if(!class_exists('WCPST_ProductPage.php'))
		require_once('classes/frontend/WCPST_ProductPage.php');
	$wcpst_product_page = new WCPST_ProductPage();
	
	if(!class_exists('WCPST_Option.php'))
		require_once('classes/com/WCPST_Option.php');
	$wcpst_options = new WCPST_Option();
	
	if(!class_exists('WCPST_GeneralOptionsPage.php'))
		require_once('classes/admin/WCPST_GeneralOptionsPage.php');
	
	include 'classes/com/WCPST_Globals.php';
	
	add_action('admin_menu', 'wcpst_init_admin_panel');
	add_action( 'admin_init', 'wcpst_register_scripts');
}

function wcpst_register_scripts()
{
	//register_setting('wcpst_options_group', 'wcpst_options');
	
	/* if(isset($_GET['page']) && $_GET['page'] == "woocommerce-product-stats-page")
		WCPST_Html::enqueue_scripts(); */
}
function wcpst_init_admin_panel()
{ 
	if(!current_user_can('manage_woocommerce'))
		return;
	$place = wcpst_get_free_menu_position(56 , 0.1);
	//add_menu_page( __('Products stats', 'woocommerce-product-stats'), __('Products stats', 'woocommerce-product-stats'), 'manage_woocommerce', 'wcps-dashboard-stats', 'wcpst_load_bulk_editor_page', 'dashicons-tag', $place);
	add_submenu_page('edit.php?post_type=product',  __('Stats', 'woocommerce-product-stats'), __('Stats', 'woocommerce-product-stats'), 'manage_woocommerce', 'woocommerce-product-stats-page', 'wcpst_load_product_stats_page');

	$wcpst_general_options_page = new WCPST_GeneralOptionsPage();
}
function wcpst_load_product_stats_page()
{
	 if(!class_exists('WCPST_StatsPage'))
		require_once('classes/admin/WCPST_StatsPage.php');
	$stats_page = new WCPST_StatsPage();
	$stats_page->render_page();
}
function wcpst_get_free_menu_position($start, $increment = 0.3)
{
	foreach ($GLOBALS['menu'] as $key => $menu) {
		$menus_positions[] = $key;
	}

	if (!in_array($start, $menus_positions)) return $start;

	/* the position is already reserved find the closet one */
	while (in_array($start, $menus_positions)) {
		$start += $increment;
	}
	return $start;
}
function wcpst_var_dump($var)
{
	echo "<pre>";
	var_dump($var);
	echo "</pre>";
}
?>